"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = __importStar(require("fs"));
var child_process_1 = require("child_process");
var FFmpeg = /** @class */ (function () {
    function FFmpeg(thumbnail, ffmpegPath, config) {
        this.config = {
            quality: 2,
            codec: "mjpeg",
            filter: "image2",
            timestamp: "00:00:10",
            width: 180,
            height: 180
        };
        this.input = "";
        this.config = __assign(__assign({}, this.config), config);
        this.path = ffmpegPath || "/opt/bin/ffmpeg";
        this.thumbnail = thumbnail;
    }
    FFmpeg.prototype.setConfig = function (config) {
        this.config = __assign(__assign({}, this.config), config);
    };
    FFmpeg.prototype.setInput = function (input) {
        if (!input.toLowerCase().match(/http[s]?:\/\//) && !fs.existsSync(input))
            throw new FFmpegException("Invalid file path/url given.");
        this.input = input;
    };
    FFmpeg.prototype.setFFmpegPath = function (path) {
        if (!this.testFFmpegPath(path))
            throw new FFmpegException("Invalid file permissions.\n " + path + " is not executable");
        this.path = path;
    };
    FFmpeg.prototype.testFFmpegPath = function (path) {
        if (!path)
            path = this.path;
        if (!fs.existsSync(path))
            throw new FFmpegException("Supplied FFmpeg path does not exist: " + path);
        try {
            fs.accessSync(path, fs.constants.X_OK);
            return true;
        }
        catch (err) {
            return false;
        }
    };
    FFmpeg.prototype.generateThumbnail = function (thumbnail) {
        if (!thumbnail)
            thumbnail = this.thumbnail;
        var writeStream = fs.createWriteStream("/tmp/screenshot." + thumbnail.getType());
        this.config = __assign(__assign({}, this.config), thumbnail.getFFmpegConfig());
        this.setInput(thumbnail.getInput());
        var ffmpeg = child_process_1.spawn(this.path, this.generateArguements());
        return new Promise(function (resolve, reject) {
            ffmpeg.on("error", function (err, stdout, stderr) {
                /*console.log(err);
                console.log('ffmpeg stdout:\n' + stdout);
                console.log('ffmpeg stderr:\n' + stderr);*/
                throw new FFmpegException("An error occurred while trying to executed FFmpeg: " + err);
            });
            ffmpeg.on("close", function (code, signal) {
                if (code !== 0) {
                    reject("FFmpeg exited with code " + code + ".\n Signal : " + signal);
                }
                writeStream.end();
                resolve(code);
            });
            writeStream.on("error", function (err) {
                reject("An error occurred while writing to the file : " + err);
            });
            ffmpeg.on("end", function () {
                writeStream.end();
            });
            ffmpeg.stdout.pipe(writeStream)
                .on("error", function (err) {
                reject("An error occurred while writing to the file : " + err);
            });
        });
    };
    FFmpeg.prototype.generateArguements = function () {
        var args = [
            "-ss", this.config.timestamp,
            "-i", this.input,
            "-vf", "thumbnail,scale=" + this.config.width + ":" + this.config.height,
            "-qscale:v", this.config.quality.toString(),
            "-frames:v", "1",
        ];
        args.push("-f", this.config.filter || "image2pipe");
        if (this.config.codec)
            args.push("-c:v", this.config.codec);
        if (this.config.codec === "png")
            args.push("-pred", "mixed");
        args.push("pipe:1");
        return args;
    };
    return FFmpeg;
}());
exports.default = FFmpeg;
;
/**
 *
 *           "-ss","00:00:05", // time to take screenshot
          "-i", target, // url to stream from
          "-vf", "thumbnail,scale="+thumbWidth+":"+thumbHeight,
          "-qscale:v" ,"2",
          "-frames:v", "1",
          "-f", "image2",
          "-c:v", "mjpeg",
 */
var FFmpegException = /** @class */ (function (_super) {
    __extends(FFmpegException, _super);
    function FFmpegException() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return FFmpegException;
}(Error));
