import { FFmpegConfig } from "./ffmpeg";
export interface ThumbnailConfig {
    outputBucket?: string;
    outputKey?: string;
    path?: string;
    width: number;
    height: number;
    time: string;
    prefix: string;
    suffix?: string;
    type?: string;
    quality: number;
}
export default class Thumbnail {
    protected config: ThumbnailConfig;
    protected generated: boolean;
    protected type?: string;
    protected input: string;
    protected fileName: string;
    constructor(input: string, config?: ThumbnailConfig);
    private parseInput;
    getOutput(): string;
    isGenerated(): boolean;
    setTime(time: string): void;
    getTime(): string;
    setType(type: string): void;
    getType(): string;
    getInput(): string;
    getFFmpegConfig(): FFmpegConfig;
    getConfig(): ThumbnailConfig;
}
export declare class S3Thumbnail extends Thumbnail {
    private bucket;
    private originalBucket;
    private key;
    constructor(bucket: string, key: string, config?: ThumbnailConfig);
    getS3Url(): string;
    getInput(): string;
    getBucket(): string;
    getKey(): string;
}
