import S3 from "aws-sdk/clients/s3";
import Thumbnail, { S3Thumbnail, ThumbnailConfig } from "./thumbnail";
interface ThumbnailerConfig {
    ffmpegPath?: string;
    bucket?: string;
    allowedFileTypes: string[];
}
interface S3Bucket {
    name: string;
    ownerIdentity: Object;
    arn: string;
}
interface S3Object {
    key: string;
    size: number;
    eTag: string;
    sequencer: string;
}
export interface S3Record {
    s3SchemaVersion: number;
    configurationId: string;
    bucket: S3Bucket;
    object: S3Object;
}
export default class Thumbnailer {
    protected config: ThumbnailerConfig;
    private input;
    constructor(input: string, config?: ThumbnailerConfig);
    createThumbnail(config?: ThumbnailConfig): Promise<any>;
    generateThumbnail(thumbnail: Thumbnail): Promise<any>;
}
export declare class S3Thumbnailer extends Thumbnailer {
    private key;
    private bucket;
    private client;
    constructor(s3Record: S3Record, S3Config?: S3.ClientConfiguration, config?: ThumbnailerConfig);
    createThumbnail(config?: ThumbnailConfig): Promise<string>;
    setS3Options(config: S3.ClientConfiguration): void;
    generateThumbnail(thumbnail: S3Thumbnail): Promise<string>;
    getKey(): string;
    getBucket(): string;
    setKey(key: string): ThisType<S3Thumbnailer>;
    setBucket(bucket: string): ThisType<S3Thumbnailer>;
}
export {};
