"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.S3Thumbnailer = void 0;
var s3_1 = __importDefault(require("aws-sdk/clients/s3"));
var fs_1 = require("fs");
var thumbnail_1 = __importStar(require("./thumbnail"));
var util_1 = require("./util");
var ffmpeg_1 = __importDefault(require("./ffmpeg"));
;
var Thumbnailer = /** @class */ (function () {
    function Thumbnailer(input, config) {
        this.config = {
            ffmpegPath: "/opt/bin/ffmpeg",
            allowedFileTypes: ["mov", "mpg", "mpeg", "mp4", "wmv", "avi"],
        };
        this.input = input;
        this.config = __assign(__assign({}, this.config), config);
    }
    Thumbnailer.prototype.createThumbnail = function (config) {
        var _this = this;
        var thumb = new thumbnail_1.default(this.input, config);
        return new Promise(function (resolve, reject) {
            _this.generateThumbnail(thumb).then(function () { return resolve(true); }, function () { return reject(); });
        });
    };
    Thumbnailer.prototype.generateThumbnail = function (thumbnail) {
        var ffmpeg = new ffmpeg_1.default(thumbnail, this.config.ffmpegPath);
        return new Promise(function (resolve, reject) {
            ffmpeg.generateThumbnail().then(function (value) {
                fs_1.promises.copyFile("/tmp/screenshot." + thumbnail.getType, thumbnail.getOutput()).then(function () { return resolve(true); }, function () { return reject(); });
            }, function (value) { return reject(value); });
        });
    };
    return Thumbnailer;
}());
exports.default = Thumbnailer;
var S3Thumbnailer = /** @class */ (function (_super) {
    __extends(S3Thumbnailer, _super);
    function S3Thumbnailer(s3Record, S3Config, config) {
        var _this = _super.call(this, "", config) || this;
        _this.client = new s3_1.default();
        _this.key = util_1.decodeKey(s3Record.object.key);
        if (!util_1.isValidType(_this.key, _this.config.allowedFileTypes))
            throw new Error("Invalid filetype supplied");
        _this.bucket = s3Record.bucket.name;
        _this.client = new s3_1.default(S3Config);
        return _this;
    }
    S3Thumbnailer.prototype.createThumbnail = function (config) {
        var thumb = new thumbnail_1.S3Thumbnail(this.bucket, this.key, config);
        return this.generateThumbnail(thumb);
    };
    S3Thumbnailer.prototype.setS3Options = function (config) {
        this.client = new s3_1.default(config);
    };
    S3Thumbnailer.prototype.generateThumbnail = function (thumbnail) {
        var _this = this;
        var ffmpeg = new ffmpeg_1.default(thumbnail, this.config.ffmpegPath);
        return new Promise(function (resolve, reject) {
            ffmpeg.generateThumbnail().then(function (value) {
                var tmpFile = fs_1.createReadStream("/tmp/screenshot." + thumbnail.getType());
                var params = {
                    Bucket: thumbnail.getBucket(),
                    Key: thumbnail.getOutput(),
                    Body: tmpFile,
                    ContentType: "image/" + thumbnail.getType(),
                    Metadata: {
                        thumbnail: "TRUE"
                    }
                };
                if (value !== 0) {
                    reject(value);
                }
                else {
                    _this.client.upload(params, function (err, _data) {
                        if (!err) {
                            resolve("Successfully uploaded " + thumbnail.getOutput());
                        }
                        else {
                            reject(err);
                        }
                    });
                }
            }, function (value) { return reject(value); });
        });
    };
    S3Thumbnailer.prototype.getKey = function () { return this.key; };
    S3Thumbnailer.prototype.getBucket = function () { return this.bucket; };
    S3Thumbnailer.prototype.setKey = function (key) {
        this.key = key;
        return this;
    };
    S3Thumbnailer.prototype.setBucket = function (bucket) {
        this.bucket = bucket;
        return this;
    };
    return S3Thumbnailer;
}(Thumbnailer));
exports.S3Thumbnailer = S3Thumbnailer;
